// 
//  Case.m
//  MatrixMaster
//
//  Created by ClarkJJ on 8/15/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "Case.h"

#import "Value.h"
#import "Result.h"

@implementation Case


- (NSString *)name
{
	
	NSMutableString * n = [[[NSMutableString alloc] init] autorelease];
	NSEnumerator * valueEnum = [[self valueForKey:@"values"] objectEnumerator];
	id nextValue;
	while (nextValue = [valueEnum nextObject]){
		[n appendFormat:@"%@:%@\r", [nextValue valueForKeyPath:@"parameter.name"], [nextValue valueForKey:@"name"]];
	}
	
	return n;

}


- (NSString *)rallyName
{
	
	NSMutableString * n = [[[NSMutableString alloc] init] autorelease];
	NSArray * values = [self valueForKey:@"values"];
	NSEnumerator * valueEnum = [values objectEnumerator];
	id nextValue;
	while (nextValue = [valueEnum nextObject]){
		[n appendFormat:@"%@:%@ , ", [nextValue valueForKeyPath:@"parameter.name"], [nextValue valueForKey:@"name"]];
	}
	
	return [n substringToIndex:([n length] - 3)];
	
}




- (NSString *)expectedResult 
{
    NSString * tmpValue;
    
    [self willAccessValueForKey: @"expectedResult"];
    tmpValue = [self primitiveValueForKey: @"expectedResult"];
    [self didAccessValueForKey: @"expectedResult"];
    
    return tmpValue;
}

- (void)setExpectedResult:(NSString *)value 
{
    [self willChangeValueForKey: @"expectedResult"];
    [self setPrimitiveValue: value forKey: @"expectedResult"];
    [self didChangeValueForKey: @"expectedResult"];
}

- (BOOL)validateExpectedResult: (id *)valueRef error:(NSError **)outError 
{
    // Insert custom validation logic here.
    return YES;
}

- (NSString *)steps 
{
    NSString * tmpValue;
    
    [self willAccessValueForKey: @"steps"];
    tmpValue = [self primitiveValueForKey: @"steps"];
    [self didAccessValueForKey: @"steps"];
    
    return tmpValue;
}

- (void)setSteps:(NSString *)value 
{
    [self willChangeValueForKey: @"steps"];
    [self setPrimitiveValue: value forKey: @"steps"];
    [self didChangeValueForKey: @"steps"];
}

- (BOOL)validateSteps: (id *)valueRef error:(NSError **)outError 
{
    // Insert custom validation logic here.
    return YES;
}


- (void)addValuesObject:(Value *)value 
{    
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    
    [self willChangeValueForKey:@"values" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    
    [[self primitiveValueForKey: @"values"] addObject: value];
    
    [self didChangeValueForKey:@"values" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    
    [changedObjects release];
}

- (void)removeValuesObject:(Value *)value 
{
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    
    [self willChangeValueForKey:@"values" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    
    [[self primitiveValueForKey: @"values"] removeObject: value];
    
    [self didChangeValueForKey:@"values" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    
    [changedObjects release];
}



- (void)addResultsObject:(Result *)value 
{    
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    
    [self willChangeValueForKey:@"results" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    
    [[self primitiveValueForKey: @"results"] addObject: value];
    
    [self didChangeValueForKey:@"results" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    
    [changedObjects release];
}

- (void)removeResultsObject:(Result *)value 
{
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    
    [self willChangeValueForKey:@"results" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    
    [[self primitiveValueForKey: @"results"] removeObject: value];
    
    [self didChangeValueForKey:@"results" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    
    [changedObjects release];
}



- (BOOL)validateResults: (id *)valueRef error:(NSError **)outError 
{
    // Insert custom validation logic here.
    return YES;
}

@end
