// 
//  Result.m
//  MatrixMaster
//
//  Created by Jeremy Clark on 2/28/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "Result.h"

#import "Value.h"
#import "Build.h"

@implementation Result 


- (NSString *)valueMapString
{
	
	NSString * valueMapString = [[NSMutableString alloc] init];
	NSEnumerator * valueEnum = [[self valueForKey:@"values"] objectEnumerator];
	id nextValue;
	while (nextValue = [valueEnum nextObject]){
		[valueMapString appendString:[[[nextValue objectID] URIRepresentation] absoluteString]];
	}
	return valueMapString;

}

- (NSString *)status 
{
    NSString * tmpValue;
    
    [self willAccessValueForKey: @"status"];
    tmpValue = [self primitiveValueForKey: @"status"];
    [self didAccessValueForKey: @"status"];
    
    return tmpValue;
}

- (void)setStatus:(NSString *)value 
{
    [self willChangeValueForKey: @"status"];
    [self setPrimitiveValue: value forKey: @"status"];
    [self didChangeValueForKey: @"status"];
}

- (BOOL)validateStatus: (id *)valueRef error:(NSError **)outError 
{
    // Insert custom validation logic here.
    return YES;
}


- (void)addValuesObject:(Value *)value 
{    
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    
    [self willChangeValueForKey:@"values" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    
    [[self primitiveValueForKey: @"values"] addObject: value];
    
    [self didChangeValueForKey:@"values" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    
    [changedObjects release];
}

- (void)removeValuesObject:(Value *)value 
{
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    
    [self willChangeValueForKey:@"values" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    
    [[self primitiveValueForKey: @"values"] removeObject: value];
    
    [self didChangeValueForKey:@"values" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    
    [changedObjects release];
}


- (Build *)build 
{
    id tmpObject;
    
    [self willAccessValueForKey: @"build"];
    tmpObject = [self primitiveValueForKey: @"build"];
    [self didAccessValueForKey: @"build"];
    
    return tmpObject;
}

- (void)setBuild:(Build *)value 
{
    [self willChangeValueForKey: @"build"];
    [self setPrimitiveValue: value
                     forKey: @"build"];
    [self didChangeValueForKey: @"build"];
}


- (BOOL)validateBuild: (id *)valueRef error:(NSError **)outError 
{
    // Insert custom validation logic here.
    return YES;
}

@end
