//
//  MyDocument.h
//  MatrixMaster
//
//  Created by Jeremy Clark on 2/26/07.
//  Copyright __MyCompanyName__ 2007 . All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "FlippedScrollView.h"

@interface MyDocument : NSPersistentDocument {
	
	//Outlets
	IBOutlet NSArrayController * xPlotParametersController;
	IBOutlet NSArrayController * yPlotParametersController;
	IBOutlet NSArrayController * buildController;
	IBOutlet NSArrayController * parameterController;
	IBOutlet NSArrayController * resultsController;
	IBOutlet NSArrayController * selectedValueController;
	IBOutlet NSArrayController * m_casesController;
	IBOutlet NSArrayController * m_plottedCombinationsController;
	IBOutlet NSTableView * m_plottedCombinationsTable;
	IBOutlet NSMatrix * m_resultMatrix;
	IBOutlet NSMatrix * xLabelMatrix;
	IBOutlet NSMatrix * yLabelMatrix;
	IBOutlet NSView * batchControlView;
	IBOutlet FlippedScrollView * m_matrixScrollView;
	IBOutlet NSMenu * resultContextualMenu;
	IBOutlet NSPanel * editCaseFormPanel;
	IBOutlet NSTextView * m_expectedResultFormTextView;
	IBOutlet NSTextView * m_stepsTextView;
	
	//Document (Testcase) Properties
	NSString * m_steps;
	NSString * m_expectedResult;
	NSString * m_testcaseName;
	NSArray * _parameters;
	
	
	
	//Matrix State Properties
	NSNumber * _intersectSelections;
	NSNumber * _plottedTestCount;
	NSNumber * _plottedPassCount;
	NSNumber * _plottedFailCount;
	NSNumber * _plottedExecutedCount;
	NSButtonCell * m_resultButtonCell;
	int _topSelectedRow;
	int _bottomSelectedRow;
	int _leftmostSelectedColumn;
	int _rightmostSelectedColumn;
	NSColor * _defaultButtonColor;
	
	
	//Mode Properties
	NSNumber * _mode;
	
	
	
	
	
	
}

- (IBAction)updateMatrix:(id)sender;
- (IBAction)selectColumn:(id)sender;
- (IBAction)selectRow:(id)sender;
- (IBAction)removeValue:(id)sender;
- (IBAction)logRadar:(id)sender;
- (IBAction)showCaseDetails:(id)sender;
- (IBAction)editSelectedCases:(id)sender;
- (IBAction)closeEditPanel:(id)sender;
- (IBAction)exportToRallyCSV:(id)sender;




//Testcase Property accessors
- (NSString *)testcaseName;
- (void)setTestcaseName:(NSString *)name;
- (NSString *)expectedResult;
- (void)setExpectedResult:(NSString *)expectedResult;
- (NSString *)steps;
- (void)setSteps:(NSString *)steps;
- (NSArray *)parameters;


//Current plot state
- (NSNumber *)plottedTestCount;
- (void)setPlottedTestCount:(NSNumber *)count;
- (NSNumber *)plottedPassCount;
- (void)setPlottedPassCount:(NSNumber *)count;
- (NSNumber *)plottedFailCount;
- (void)setPlottedFailCount:(NSNumber *)count;
- (NSNumber *)plottedExecutedCount;
- (void)setPlottedExecutedCount:(NSNumber *)count;
- (NSNumber *)plottedExecutedPercentage;


//Mode Properties
- (NSNumber *)mode;
- (void)setMode:(NSNumber *)num;







-(NSArray *)xAxisCombinations;
-(NSArray *)yAxisCombinations;




@end
