// 
//  Parameter.m
//  MatrixMaster
//
//  Created by Jeremy Clark on 2/28/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "Parameter.h"

#import "Value.h"

@implementation Parameter 


//OVERRIDING INIT TO BE ABLE TO PUT THE PARAMETER IN THE RIGHT DOCUMENT WHEN A "make parameter" SCRIPT COMMAND IS ISSUED. INIT ONLY GETS CALLED BY THE SCRIPT INTERFACE IN THE DOC-BASED CORE DATA app (i think. It works for now!). 
- (id)init
{
	
	NSAppleEventManager * aem = [NSAppleEventManager sharedAppleEventManager];
	NSString * descString = [[aem currentAppleEvent] description];
	NSString * documentLookupType = [[[[descString componentsSeparatedByString:@"'form':"] objectAtIndex:1] componentsSeparatedByString:@","] objectAtIndex:0];
	NSString * documentIdentifier = [[[[descString componentsSeparatedByString:@"'seld':"] objectAtIndex:1] componentsSeparatedByString:@","] objectAtIndex:0];
	

	MyDocument * scriptedDocument = NULL;
	NSDocumentController * sdc = [NSDocumentController sharedDocumentController];
	
	if ([documentLookupType isEqualTo:@"'indx'"]){//Get the window by the document index
		scriptedDocument = [[sdc documents] objectAtIndex:([documentIdentifier intValue] - 1)];
	
	
	}else if ([documentLookupType isEqualTo:@"'name'"]){ //Get the window by the name
		NSWindow * docWindow = NULL;
		documentIdentifier = [[documentIdentifier componentsSeparatedByString:@"\""] objectAtIndex:1]; 
		NSEnumerator * windowEnum = [[NSApp windows] objectEnumerator]; 
		NSWindow * nextWindow;
		while (nextWindow = [windowEnum nextObject]){
			if ([[nextWindow title] isEqualTo:documentIdentifier]){
				docWindow = nextWindow;
				[windowEnum allObjects];
			}
		}
		if (docWindow != NULL){
			scriptedDocument = [sdc documentForWindow:docWindow];
		}
	}
	
	
	if (scriptedDocument != NULL){
		NSManagedObjectContext * moc = [scriptedDocument managedObjectContext];
		return [super initWithEntity:[NSEntityDescription entityForName:@"Parameter" inManagedObjectContext:moc] insertIntoManagedObjectContext:moc];
	}else{
		return NULL;
	}
	
}







- (NSNumber *)shouldPlot 
{
    NSNumber * tmpValue;
    
    [self willAccessValueForKey: @"shouldPlot"];
    tmpValue = [self primitiveValueForKey: @"shouldPlot"];
    [self didAccessValueForKey: @"shouldPlot"];
    
    return tmpValue;
}

- (void)setShouldPlot:(NSNumber *)value 
{
    [self willChangeValueForKey: @"shouldPlot"];
    [self setPrimitiveValue: value forKey: @"shouldPlot"];
    [self didChangeValueForKey: @"shouldPlot"];
}

- (BOOL)validateShouldPlot: (id *)valueRef error:(NSError **)outError 
{
    // Insert custom validation logic here.
    return YES;
}

- (NSNumber *)plotAxis 
{
    NSNumber * tmpValue;
    
    [self willAccessValueForKey: @"plotAxis"];
    tmpValue = [self primitiveValueForKey: @"plotAxis"];
    [self didAccessValueForKey: @"plotAxis"];
    
    return tmpValue;
}

- (void)setPlotAxis:(NSNumber *)value 
{
    [self willChangeValueForKey: @"plotAxis"];
    [self setPrimitiveValue: value forKey: @"plotAxis"];
    [self didChangeValueForKey: @"plotAxis"];
}

- (BOOL)validatePlotAxis: (id *)valueRef error:(NSError **)outError 
{
    // Insert custom validation logic here.
    return YES;
}

- (NSString *)name 
{
    NSString * tmpValue;
    
    [self willAccessValueForKey: @"name"];
    tmpValue = [self primitiveValueForKey: @"name"];
    [self didAccessValueForKey: @"name"];
    
    return tmpValue;
}

- (void)setName:(NSString *)value 
{
    [self willChangeValueForKey: @"name"];
    [self setPrimitiveValue: value forKey: @"name"];
    [self didChangeValueForKey: @"name"];
}

- (BOOL)validateName: (id *)valueRef error:(NSError **)outError 
{
    // Insert custom validation logic here.
    return YES;
}


- (void)addValuesObject:(Value *)value 
{    
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    
    [self willChangeValueForKey:@"values" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    
    [[self primitiveValueForKey: @"values"] addObject: value];
    
    [self didChangeValueForKey:@"values" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    
    [changedObjects release];
}

- (void)removeValuesObject:(Value *)value 
{
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    
    [self willChangeValueForKey:@"values" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    
    [[self primitiveValueForKey: @"values"] removeObject: value];
    
    [self didChangeValueForKey:@"values" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    
    [changedObjects release];
}






#pragma mark-
#pragma mark SCRIPTING STUFF



- (NSString *)uniqueID
{
	return [[[self valueForKey:@"objectID"] URIRepresentation] absoluteString];
}


/*
- (unsigned int)countOfValues {

	return [[self valueForKey:@"values"] count]; 
}


- (Value *)objectInValuesAtIndex:(unsigned int)index {
    // implementation specific code
	return [[self valueForKey:@"values"] objectAtIndex:index];
}



- (void)insertObject:(Value *)transaction inTransactionsAtIndex:(unsigned int)index {
    // implementation specific code
    return;
}

- (void)removeObjectFromTransactionsAtIndex:(unsigned int)index {
    // implementation specific code
    return;
}

*/


- (MyDocument *)document
{
	
	NSDocumentController * sdc = [NSDocumentController sharedDocumentController];
	
	//Get the Persistent Store URL
	NSManagedObjectContext * moc = [self managedObjectContext];
	NSPersistentStoreCoordinator * psc = [moc persistentStoreCoordinator];
	NSURL * psURL = [psc URLForPersistentStore:[[psc persistentStores] objectAtIndex:0]];//
	
	//Repeat with all open documents
	return [sdc documentForURL:psURL];
	
}
	


- (NSScriptObjectSpecifier *)objectSpecifier {
    NSArray *parameters = [[self document] parameters];
    unsigned index = [parameters indexOfObjectIdenticalTo:self];
    if (index != NSNotFound) {
        NSScriptObjectSpecifier *containerRef = [[self document] objectSpecifier];
		//return [[[NSUniqueIDSpecifier alloc] initWithContainerClassDescription:[containerRef keyClassDescription] containerSpecifier:containerRef key:@"parameters" uniqueID:[self uniqueID]] autorelease];
        return [[[NSIndexSpecifier allocWithZone:[self zone]] initWithContainerClassDescription:[containerRef keyClassDescription] containerSpecifier:containerRef key:@"parameters" index:index] autorelease];
    } else {
        return nil;
    }
}


@end
