// 
//  Value.m
//  MatrixMaster
//
//  Created by Jeremy Clark on 2/28/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "Value.h"


@implementation Value 


- (id)init
{
	NSManagedObjectContext * moc = [[[NSApp orderedDocuments] objectAtIndex:0] managedObjectContext];
	return [super initWithEntity:[NSEntityDescription entityForName:@"Value" inManagedObjectContext:moc] insertIntoManagedObjectContext:nil];
}


- (NSNumber *)isDefault 
{
    NSNumber * tmpValue;
    
    [self willAccessValueForKey: @"isDefault"];
    tmpValue = [self primitiveValueForKey: @"isDefault"];
    [self didAccessValueForKey: @"isDefault"];
    
    return tmpValue;
}

- (void)setIsDefault:(NSNumber *)value 
{
    [self willChangeValueForKey: @"isDefault"];
    [self setPrimitiveValue: value forKey: @"isDefault"];
    [self didChangeValueForKey: @"isDefault"];
}

- (BOOL)validateIsDefault: (id *)valueRef error:(NSError **)outError 
{
    // Insert custom validation logic here.
    return YES;
}




- (NSNumber *)shouldPlot 
{
    NSNumber * tmpValue;
    
    [self willAccessValueForKey: @"shouldPlot"];
    tmpValue = [self primitiveValueForKey: @"shouldPlot"];
    [self didAccessValueForKey: @"shouldPlot"];
    
    return tmpValue;
}

- (void)setShouldPlot:(NSNumber *)value 
{
    [self willChangeValueForKey: @"shouldPlot"];
    [self setPrimitiveValue: value forKey: @"shouldPlot"];
    [self didChangeValueForKey: @"shouldPlot"];
}

- (BOOL)validateShouldPlot: (id *)valueRef error:(NSError **)outError 
{
    // Insert custom validation logic here.
    return YES;
}

- (NSString *)name 
{
    NSString * tmpValue;
    
    [self willAccessValueForKey: @"name"];
    tmpValue = [self primitiveValueForKey: @"name"];
    [self didAccessValueForKey: @"name"];
    
    return tmpValue;
}

- (void)setName:(NSString *)value 
{
    [self willChangeValueForKey: @"name"];
    [self setPrimitiveValue: value forKey: @"name"];
    [self didChangeValueForKey: @"name"];
}

- (BOOL)validateName: (id *)valueRef error:(NSError **)outError 
{
    // Insert custom validation logic here.
    return YES;
}


- (NSManagedObject *)parameter 
{
    id tmpObject;
    
    [self willAccessValueForKey: @"parameter"];
    tmpObject = [self primitiveValueForKey: @"parameter"];
    [self didAccessValueForKey: @"parameter"];
    
    return tmpObject;
}

- (void)setParameter:(NSManagedObject *)value 
{
    [self willChangeValueForKey: @"parameter"];
    [self setPrimitiveValue: value
                     forKey: @"parameter"];
    [self didChangeValueForKey: @"parameter"];
}


- (BOOL)validateParameter: (id *)valueRef error:(NSError **)outError 
{
    // Insert custom validation logic here.
    return YES;
}





- (void)addCasesObject:(Case *)value 
{    
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    
    [self willChangeValueForKey:@"cases" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    
    [[self primitiveValueForKey: @"cases"] addObject: value];
    
    [self didChangeValueForKey:@"cases" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    
    [changedObjects release];
}

- (void)removeCasesObject:(Case *)value 
{
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    
    [self willChangeValueForKey:@"cases" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    
    [[self primitiveValueForKey: @"cases"] removeObject: value];
    
    [self didChangeValueForKey:@"cases" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    
    [changedObjects release];
}



//SCRIPTING STUFF
#pragma mark -
#pragma mark SCRIPTING STUFF


- (NSString *)uniqueID
{
	return [[[self valueForKey:@"objectID"] URIRepresentation] absoluteString];
}



- (NSScriptObjectSpecifier *)objectSpecifier {
    NSArray *values = [self valueForKey:@"parameter.values"];
    unsigned index = [values indexOfObjectIdenticalTo:self];
    if (index != NSNotFound) {
        NSScriptObjectSpecifier *containerRef = [[self valueForKey:@"parameter"] objectSpecifier];
        return [[[NSIndexSpecifier allocWithZone:[self zone]] initWithContainerClassDescription:[containerRef keyClassDescription] containerSpecifier:containerRef key:@"orderedValues" index:index] autorelease];
    } else {
        return nil;
    }
}










@end
